//<c>   Copyright 1992-2000 by Gerry J. Danen; all rights reserved.

//<t>   Generate Bingo Numbers

#include "gd_tools.h"


#define pgVERS_ "V2.02"
#define pgTITL_ "Generate Bingo Numbers"
#define pgCOPR_ "1992"


#define GENMAX  75                              // change this number for more
                                                // or less numbers to generate
int     rmax=GENMAX ;
ULONG   rlow=1, rhigh=75, t1=0 ;
ULONG   far tbl1[GENMAX+1] ;


void    insert_in_1( ULONG n )
{
    tbl1[t1] = n ;
    t1 += 1 ;
}


int     found_in_table( ULONG n )
{
    register int i ;
    int top ;

    top = (int)t1 - 1 ;
    LOOP ( i, 0, top, 1 )
    {
        if ( n == tbl1[i] )
            return( TRUE );
    }

    return( FALSE );
}


ULONG   rnum( ULONG lower, ULONG upper )

//      Return a random number between lower and upper,
//      including lower and upper.
{
    ULONG       diff, result ;
    BOOL        checking = TRUE ;

    diff = upper - lower + 1 ;
    while ( checking )
    {
        rand();                                 // call rand() twice to create a 6-digit number
        result = ((ULONG) rand()) * 1000 ;
        result = result + (ULONG) (rand() MOD 1000);
        result = (result MOD diff) + lower;

        //  check for duplicates
        checking = FALSE ;
        if ( found_in_table(result) )
        {
//          fprintf( stderr, "\rDuplicate number %06ld\n", result );
            checking = TRUE ;
        }
    }
    //  put in table
    if ( t1 < GENMAX )
        insert_in_1( result );
    else
        fprintf( stderr, "Cannot insert random number in the tables\n" );
    return( result );
}


void    print_number( ULONG number )
{
    static char c ;

    if ( number < 16 )
        c = 'B' ;
    else
    if ( number < 31 )
        c = 'I' ;
    else
    if ( number < 46 )
        c = 'N' ;
    else
    if ( number < 61 )
        c = 'G' ;
    else
    if ( number < 76 )
        c = 'O' ;
    else
        c = '?' ;

    printf( " %c-%ld,", c, number );
}


void    main( int argc, char *argv[] )
{
    register int x ;
    ULONG       r ;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );

    fprintf( stderr, "\nBingo numbers: " );

    tm_sleep_secs( 2 );                         // delay so we don't repeat between runs
    srand( (unsigned) time(NULL) );             // seed random number generator
    rand();                                     // just so we don't start on the first random number

    LOOP ( x, 1, rmax, 1 )
    {
        r = rnum( rlow, rhigh );
    }

    rmax = 9 ;                                  // change this number for more
                                                // or less numbers to print
    r = 0 ;                                     // base 0
    LOOP ( x, 0, rmax, 1 )
    {
        print_number( tbl1[x] );
        tm_sleep_msecs( 99 );                   // delay
    }
    printf( "\b \n" );
    exit( 0 );
}
